<div class="appt-classes-container">
  <kendo-grid [data]="gridView" [pageSize]="pageSize" [skip]="skip" [pageable]="true" [columnMenu]="false"
              [filterable]="true" [filter]="state.filter"
              (dataStateChange)="dataStateChange($event)" [groupable]="false"
              [reorderable]="reorder" [sortable]="{
              allowUnsort: allowUnsort,
              mode: multiple ? 'multiple' : 'single'
            }" [sort]="sort" (sortChange)="sortChange($event)" (groupChange)="groupChange($event)">

    <kendo-grid-column field="startDateUTCStr" title="Date" [width]="100">
    </kendo-grid-column>

    <kendo-grid-column field="startDateUTCTime" title="Time" [width]="100">
    </kendo-grid-column>

    <kendo-grid-column field="typeVal" title="Booking Type" [width]="180">
    </kendo-grid-column>

    <kendo-grid-column field="offeringsVal" title="Offerings" [width]="100">
    </kendo-grid-column>

    <kendo-grid-column field="practitionerName" title="Practitioner" [width]="120">
    </kendo-grid-column>

    <kendo-grid-column field="caseName" title="Case" [width]="100">
    </kendo-grid-column>

    <kendo-grid-column field="referralName" title="Referral" [width]="100">
    </kendo-grid-column>

    <kendo-grid-column field="payerName" title="Payer" [width]="100">
    </kendo-grid-column>

    <kendo-grid-column field="currentStatus" title="Status" [width]="100">
      <ng-template kendoGridCellTemplate let-dataItem let-rowIndex="rowIndex">
        <label class="m-0 appt-class-status"
               [matTooltip]="dataItem.statusReasonMessage"
               [ngClass]="getClassByStatus(dataItem.status, dataItem.confirmationStatus)">{{dataItem.currentStatus}}</label>
      </ng-template>
    </kendo-grid-column>

    <kendo-grid-column field="uploadedDate" title="Payment" [width]="100">
      <ng-template kendoGridCellTemplate let-dataItem let-rowIndex="rowIndex">
        {{ dataItem.uploadedDate | date: 'dd-MM-yyyy' }}
      </ng-template>
    </kendo-grid-column>

    <kendo-grid-column field="note" title="Notes" [width]="80">
      <ng-template kendoGridCellTemplate let-dataItem let-rowIndex="rowIndex">
        <mat-icon class="cursor-pointer" *ngIf="dataItem.note" [matTooltip]="dataItem.note" style="color: #979797;">
          info
        </mat-icon>
      </ng-template>
    </kendo-grid-column>

    <kendo-grid-column title="Action" [width]="80">
      <ng-template kendoGridCellTemplate let-dataItems let-rowIndex="rowIndex">
        <button (click)="openApptActionPopup(dataItems, $event)"
                class="item-setting-btn border-0 bg-transparent cursor-pointer"
                id="action_{{dataItems.appointmentsId}}" [disabled]="dataItems.status === DELETED">
          <mat-icon class="m-0" style="color: #979797;">settings</mat-icon>
        </button>
      </ng-template>
    </kendo-grid-column>
  </kendo-grid>
</div>


<dx-popover #pendingStatusPopup class="sdlr_popup" position="top" [width]="176" [height]="'auto'"
            [shading]="false" [position]="{my: 'right top', at: 'right bottom'}">
  <div *dxTemplate="let data of 'content'">
    <button *appAccess="moduleName; lookFor: ['E']" class="prctioner-filter-button text-left" (click)="doApptClassAction(CANCEL)">
      Cancel {{clickedItem?.type == TYPE_APPT ? 'Appointment' : 'Class'}}
    </button>
    <button *appAccess="moduleName; lookFor: ['E']" class="prctioner-filter-button text-left" (click)="doApptClassAction(MISSED)">
      Missed {{clickedItem?.type == TYPE_APPT ? 'Appointment' : 'Class'}}
    </button>
    <button *appAccess="moduleName; lookFor: ['E', 'D']" class="prctioner-filter-button text-left" (click)="doApptClassAction(DELETE)">
      Delete {{clickedItem?.type == TYPE_APPT ? 'Appointment' : 'Class'}}
    </button>
    <button class="prctioner-filter-button text-left" (click)="doApptClassAction(GO_TO)">
      Go to {{clickedItem?.type == TYPE_APPT ? 'Appointment' : 'Class'}}
    </button>
  </div>
</dx-popover>

<dx-popover #cancelledStatusPopup class="sdlr_popup" position="top" [width]="176" [height]="'auto'"
            [shading]="false" [position]="{my: 'right top', at: 'right bottom'}">
  <div *dxTemplate="let data of 'content'">
    <button *appAccess="moduleName; lookFor: ['E']" class="prctioner-filter-button text-left" (click)="doApptClassAction(RESET)">
      Reset {{clickedItem?.type == TYPE_APPT ? 'Appointment' : 'Class'}}
    </button>
  </div>
</dx-popover>

<dx-popover #missedStatusPopup class="sdlr_popup" position="top" [width]="176" [height]="'auto'"
            [shading]="false" [position]="{my: 'right top', at: 'right bottom'}">
  <div *dxTemplate="let data of 'content'">
    <button *appAccess="moduleName; lookFor: ['E']" class="prctioner-filter-button text-left" (click)="doApptClassAction(RESET)">
      Reset {{clickedItem?.type == TYPE_APPT ? 'Appointment' : 'Class'}}
    </button>
    <button class="prctioner-filter-button text-left" (click)="doApptClassAction(GO_TO)">
      Go to {{clickedItem?.type == TYPE_APPT ? 'Appointment' : 'Class'}}
    </button>
  </div>
</dx-popover>

<dx-popover #completedStatusPopup class="sdlr_popup" position="top" [width]="176" [height]="'auto'"
            [shading]="false" [position]="{my: 'right top', at: 'right bottom'}">
  <div *dxTemplate="let data of 'content'">
    <button *appAccess="moduleName; lookFor: ['E']" class="prctioner-filter-button text-left" (click)="doApptClassAction(RESET)">
      Reset {{clickedItem?.type == TYPE_APPT ? 'Appointment' : 'Class'}}
    </button>
    <button *appAccess="moduleName; lookFor: ['E']" class="prctioner-filter-button text-left" (click)="doApptClassAction(EDIT_INVOICE)">
      Edit invoice
    </button>
    <button class="prctioner-filter-button text-left" (click)="doApptClassAction(GO_TO)">
      Go to {{clickedItem?.type == TYPE_APPT ? 'Appointment' : 'Class'}}
    </button>
  </div>
</dx-popover>

<ng-template #deleteConfirmation>
  <div style="padding: 20px;">
    <span>Deleted appointment can not be restored.</span>
  </div>
</ng-template>

